import requests, re
from time import sleep
from bs4 import BeautifulSoup

def get_people(lab):
    soup = BeautifulSoup(requests.get("https://fabacademy.org/2023/people.html").content, 'html.parser')

    lab_divs = soup.find_all("div", {"class": "lab"})

    lab_names = [div.find('h3').find('a').text for div in lab_divs if div.find('h3').find('a')]

    lab_num = None

    for i, lab_name in enumerate(lab_names):
        if lab.lower() in lab_name.lower():
            lab_num = i
            break

    if lab_num is None:
        print("Error: lab not found -- please check for typos and that the entered lab name matches the Fab Academy website")
    
    lab_div = lab_divs[i]

    lis = lab_div.find_all("li")

    As = [li.find("a") for li in lis]

    names = [a.text.strip().lower() for a in As]

    names_formatted = ["-".join(n.split(" ")) for n in names]

    return names_formatted

def get_dict(name, lab):

    pattern = re.compile(f"\/2023\/labs\/{lab}\/students\/(\w|-)+\/")

    response = requests.get(f"https://fabacademy.org/2023/labs/{lab}/students/{name}/.")

    soup = BeautifulSoup(response.content, 'html.parser')

    As = [li.find('a') for li in soup.find_all('li')]
    As = [x for x in As if x]

    links = []

    for a in As:
        href = a['href'].strip()
        if href not in ["#", "/.", "."] and ("." not in href) and ("#" not in href):
            links.append(f"https://fabacademy.org/2023/labs/{lab}/students/{name}/{href}")

    people_linked = {}

    print(links)

    for link in links:
        print(f"Checking {link}")
        sleep(1)
        text_content = requests.get(link).content
        for match in pattern.finditer(str(text_content)):
            print("Found match")
            print(match.group(0))
            person = match.group(0).split("/")[-2]
            if person in people_linked:
                people_linked[person] += 1
            else:
                people_linked[person] = 1

    return people_linked

def initialize():
    print("""
https://fabacademy.org/2023/labs/charlotte/students/adam-stone/
              ---
          Adam Stone
          Fab Academy
             2023 
    Charlotte Latin Fab Lab
              ---
    """)

if __name__ == "__main__":
    initialize()
    people = get_people("Charlotte Latin")
    people_dicts = {}

    print(people)

    for person in people:
        people_dicts[person] = get_dict(person, "charlotte")

    print(people_dicts)